clc
clear all
close all
%Rana
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%READ DIFFERENT QUALITY DATA%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%Assume 4x4 Tiles: 16 Tiles
Tile_res=4;
%%%%Assume 5 qualities available for each tile
num_quality=5;
%%%So RATE Table size is 16x4
%%%Assume column one is the highest rate and column 4 is the lowest rate
%%%Assume tiles are numbered in raster scan

Rate_Table=zeros(Tile_res*Tile_res,num_quality);
fileID = fopen('SizesF5Q1.txt');
A = fscanf(fileID,'%d');
for s=1:16
    Rate_Table(s,5)=A(2*s-1)+A(2*s);
end
fclose(fileID);


fileID = fopen('SizesF5Q2.txt');
A = fscanf(fileID,'%d');
for s=1:16
    Rate_Table(s,4)=A(2*s-1)+A(2*s);
end
fclose(fileID);


fileID = fopen('SizesF5Q3.txt');
A = fscanf(fileID,'%d');
for s=1:16
    Rate_Table(s,3)=A(2*s-1)+A(2*s);
end
fclose(fileID);


fileID = fopen('SizesF5Q4.txt');
A = fscanf(fileID,'%d');
for s=1:16
    Rate_Table(s,2)=A(2*s-1)+A(2*s);
end
fclose(fileID);


fileID = fopen('SizesF5Q5.txt');
A = fscanf(fileID,'%d');
for s=1:16
    Rate_Table(s,1)=A(2*s-1)+A(2*s);
end
fclose(fileID);


plot([1:5],mean(Rate_Table)./1000,'m*','MarkerSize',15)
xticks([1 2 3 4 5])
xlabel('Quality Index')
ylabel('Average Tile Sizes (KB)')



Wifi_Latencyt=[0.2:1:10 14];
Wigig_LAtencyt=[0.2:1:10.2];

wifi_Ratet=[0.1:10:70].*(10^6)/8;%bps/8--->Bps%%%THIS is done here only because file sizes are in bytes
Wigig_Ratet=[0.1 500:100:1220].*(10^6)/8;%bps/8--->Bps



%%%GEt Groups of tiles around the FOV
%%%Current implementatio is for 4x4
AllTiles=1:16;
FOV_tile=10;

Med_Q_tiles=[FOV_tile+1 FOV_tile-1 FOV_tile+Tile_res FOV_tile-Tile_res ...
    FOV_tile+Tile_res-1 FOV_tile+Tile_res+1 ...
    FOV_tile-Tile_res-1 FOV_tile-Tile_res+1];



Med_Q_tiles=Med_Q_tiles(Med_Q_tiles>=1);
Med_Q_tiles=Med_Q_tiles(Med_Q_tiles<=Tile_res*Tile_res);
Med_Q_tiles=unique(Med_Q_tiles);

if(sum(ismember(FOV_tile,[1 5 9 13])))
    Med_Q_tiles(ismember(Med_Q_tiles,[4 8 12 16]))=[];
end
if(sum(ismember(FOV_tile,[4 8 12 16])))
    Med_Q_tiles(ismember(Med_Q_tiles,[1 5 9 13]))=[];
end

AllTiles(ismember(AllTiles,[FOV_tile Med_Q_tiles]))=[];
Low_Q_tiles=AllTiles;
%%%???????
Tile_Weights=zeros(1,Tile_res*Tile_res);
Tile_Weights(FOV_tile)=80;
Tile_Weights(Med_Q_tiles)=10;
Tile_Weights(Low_Q_tiles)=1;


%%%%Assume for simplification Each group of tiles can choose one
%%%%quality only


%%%%%%FOV QUALITY can CHANGE%%%%%%%%%
All_comb=permn(1:num_quality,3);
Rate_combinations=ones(length(All_comb),3);
Rate_combinations(:,1:3)=All_comb;
%Rate of each tile
Rate=zeros(1,Tile_res*Tile_res);
Qualities=zeros(1,Tile_res*Tile_res);

interface_comb=permn(0:1,3);
Best_values_R=cell(length(Wifi_Latencyt),length(Wigig_LAtencyt),length(wifi_Ratet),length(Wigig_Ratet));
Best_values_I=cell(length(Wifi_Latencyt),length(Wigig_LAtencyt),length(wifi_Ratet),length(Wigig_Ratet));

for iterLatfi=1:length(Wifi_Latencyt)
    for iterLatGig=1:length(Wigig_LAtencyt)
        for iterRatefi=1:length(wifi_Ratet)
            for iterRateGig=1:length(Wigig_Ratet)
                %Interf for each tile
                Interf=zeros(1,Tile_res*Tile_res);
                Check_latency=zeros(size(Rate_combinations,1),size(interface_comb,1));
                Check_weights=zeros(size(Rate_combinations,1),size(interface_comb,1));
                           
                Opt_matrix=zeros(size(Rate_combinations,1),size(interface_comb,1));
                for iterRate=1:size(Rate_combinations,1)
                    cand_combin=Rate_combinations(iterRate,:);
                    Rate(FOV_tile)=Rate_Table(FOV_tile,cand_combin(1));
                    Rate(Med_Q_tiles)=Rate_Table(Med_Q_tiles,cand_combin(2));
                    Rate(Low_Q_tiles)=Rate_Table(Low_Q_tiles,cand_combin(3));
                    
                    
                    Qualities(FOV_tile)=cand_combin(1);
                    Qualities(Med_Q_tiles)=cand_combin(2);
                    Qualities(Low_Q_tiles)=cand_combin(3);
                    
                    SumWeighted_Rates=sum(Tile_Weights.*log(Rate));
                    SumWeighted_qualities=sum(Tile_Weights.*Qualities);
                   
                    %%%%%%%%%%Assume all tiles in a group will be sent with same quality
                    for iterInterf=1:size(interface_comb,1)
                        Interf(FOV_tile)=interface_comb(iterInterf,1);
                        Interf(Med_Q_tiles)=interface_comb(iterInterf,2);
                        Interf(Low_Q_tiles)=interface_comb(iterInterf,3);
                        
                        %total number of data needs to be sent thru each interface
                        wifi_R_tot=(1-Interf)*(Rate)';
                        
                        wigig_R_tot=Interf*(Rate)';
                        if(iterInterf==1)
                            Frame_Tx=(wifi_R_tot/wifi_Ratet(iterRatefi))*(10^3)+Wifi_Latencyt(iterLatfi);
                        elseif (iterInterf==8)
                            Frame_Tx=(wigig_R_tot/Wigig_Ratet(iterRateGig))*(10^3)+Wigig_LAtencyt(iterLatGig);
                        else
                        Frame_Tx=max((wifi_R_tot/wifi_Ratet(iterRatefi))*(10^3)+Wifi_Latencyt(iterLatfi),(wigig_R_tot/Wigig_Ratet(iterRateGig))*(10^3)+Wigig_LAtencyt(iterLatGig));
                        end
                        Check_latency(iterRate,iterInterf)=Frame_Tx;
                        Check_weights(iterRate,iterInterf)=SumWeighted_Rates;
                        if (Frame_Tx<=15)
                            Opt_matrix(iterRate,iterInterf)=(SumWeighted_qualities)+(400)*(1/Frame_Tx);
                        end%
                    end
                end
                if(sum(sum(Opt_matrix))~=0)
                    [I,J]=max(Opt_matrix(:));
                    [X Y]=ind2sub(size(Opt_matrix),J);
                    Best_values_R(iterLatfi,iterLatGig,iterRatefi,iterRateGig)={Rate_combinations(X,:)};
                    Best_values_I(iterLatfi,iterLatGig,iterRatefi,iterRateGig)={interface_comb(Y,:)};
                    QoE(iterLatfi,iterLatGig,iterRatefi,iterRateGig)=Opt_matrix(X,Y);
                else
                    Best_values_R(iterLatfi,iterLatGig,iterRatefi,iterRateGig)={[0 0 0]};%%0 means drop this frame
                    Best_values_I(iterLatfi,iterLatGig,iterRatefi,iterRateGig)={[-1 -1 -1]};%%-1 means drop this frame
                    QoE(iterLatfi,iterLatGig,iterRatefi,iterRateGig)=0;
                end
               
            end
        end
    end
end

figure
mesh(Wigig_LAtencyt,Wifi_Latencyt,QoE(:,:,2,2))
xlabel('WiGig Latency')
ylabel('Wifi Latency')
title('Low rate for Wifi and Wigig')

figure
mesh(Wigig_LAtencyt,Wifi_Latencyt,QoE(:,:,7,9))
xlabel('WiGig Latency')
ylabel('Wifi Latency')
title('High rate for Wifi and Wigig')
pp=reshape(QoE(1,1,:,:),length(wifi_Ratet),length(Wigig_Ratet));
figure

mesh([500:100:1220],[10.1:10:70],pp(2:end,2:end))
ylabel('Wifi Rate (Mbps)')
xlabel('WiGig Rate (Mbps)')
zlabel('QoE')
title('Low Latency for Wifi and Wigig')

pp=reshape(QoE(11,11,:,:),length(wifi_Ratet),length(Wigig_Ratet));
figure
mesh([0.1 500:100:1220],[0.1:10:70],pp)
ylabel('Wifi Rate (Mbps)')
xlabel('WiGig Rate (Mbps)')
zlabel('QoE')
title('High Latency for Wifi and Wigig')

save('TabBestChoices.mat','Best_values_R','Best_values_I')








