clc
close all
clear all

fileID = fopen('latency_wifi.txt');
Wifi_Latency = fscanf(fileID,'%f');
fclose(fileID);

fileID = fopen('latency_wigig.txt');
Wigig_LAtency = fscanf(fileID,'%f');
fclose(fileID);

fileID = fopen('rate_wifi.txt');
wifi_Rate = fscanf(fileID,'%f');
fclose(fileID);

fileID = fopen('rate_wigig.txt');
Wigig_Rate = fscanf(fileID,'%f');
fclose(fileID);

fileID = fopen('rssi_wifi.txt');
Wifi_rssi= fscanf(fileID,'%f');
fclose(fileID);

fileID = fopen('rssi_wigig.txt');
Wigig_rssi = fscanf(fileID,'%f');
fclose(fileID);

Wifi_Latencyt=[Wifi_Latency(1:66)' Wifi_Latency(68:end)'];
Wigig_LAtencyt=[Wigig_LAtency(1:66)' Wigig_LAtency(68:end)'];
wifi_Ratet=[wifi_Rate(1:66)' wifi_Rate(68:end)'];
Wigig_Ratet=[Wigig_Rate(1:66)' Wigig_Rate(68:end)'];
Wifi_rssit=[Wifi_rssi(1:66)' Wifi_rssi(68:end)'];
Wigig_rssit=[Wigig_rssi(1:66)' Wigig_rssi(68:end)'];


load('TabBestChoices.mat');


Wifi_Latencyt_Tab=[0.2:1:10 14];
Wigig_LAtencyt_Tab=[0.2:1:10.2];
wifi_Ratet_Tab=[0.1:10:70];%Mbps
Wigig_Ratet_Tab=[0.1 500:100:1220];%Mbps

Tiles_Q=zeros(length(Wifi_Latencyt),3);
Tiles_I=zeros(length(Wifi_Latencyt),3);

for t=1:length(Wifi_Latencyt)
    [c indexFiLat] = min(abs(Wifi_Latencyt_Tab-Wifi_Latencyt(t)));
    [c indexGigLat] = min(abs(Wigig_LAtencyt_Tab-Wigig_LAtencyt(t)));
    [c indexFiRate] = min(abs(wifi_Ratet_Tab-wifi_Ratet(t)));
    [c indexGigRate] = min(abs(Wigig_Ratet_Tab-Wigig_Ratet(t)));
    
    Tiles_Q(t,:)=cell2mat(Best_values_R(indexFiLat,indexGigLat,indexFiRate,indexGigRate));
    Tiles_I(t,:)=cell2mat(Best_values_I(indexFiLat,indexGigLat,indexFiRate,indexGigRate));
end

plot([1:length(Wifi_Latencyt)],Tiles_Q(:,1),'-*','MarkerEdgeColor','m' );
title('FoV Tile')
xlabel('Sampled Time Instant');
ylabel('Tile Quality');
yticks([0 1 2 3 4 5])

figure
plot([1:length(Wifi_Latencyt)],Tiles_Q(:,2),'-*','MarkerEdgeColor','m'  );
title('Neighboring Tiles')
xlabel('Sampled Time Instant');
ylabel('Tile Quality');
yticks([0 1 2 3 4 5])

figure
plot([1:length(Wifi_Latencyt)],Tiles_Q(:,3),'-*','MarkerEdgeColor','m'  );
title('Rest of Tiles')
xlabel('Sampled Time Instant');
ylabel('Tile Quality');
yticks([0 1 2 3 4 5])

figure
plot([1:length(Wifi_Latencyt)],Tiles_I(:,1),'-*','MarkerEdgeColor','m'  );
title('FoV Tile')
xlabel('Sampled Time Instant');
ylabel('Tile Selected Interface');
yticks([-1 0 1])

figure
plot([1:length(Wifi_Latencyt)],Tiles_I(:,2),'-*','MarkerEdgeColor','m'  );
title('Neighboring Tiles')
xlabel('Sampled Time Instant');
ylabel('Tile Selected Interface');
yticks([-1 0 1])

figure
plot([1:length(Wifi_Latencyt)],Tiles_I(:,3),'-*','MarkerEdgeColor','m'  );
title('Rest of Tiles')
xlabel('Sampled Time Instant');
ylabel('Tile Selected Interface');
yticks([-1 0 1])