import socket
import sys
import json
import time
import datetime
import traceback
rssi_list = []
# Create a TCP/IP socket
sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
try:
    # Connect the socket to the port where the server is listening
    server_address = ('192.222.1.2', 10000)
    #print 'connecting to %s port %s' % server_address
    sock.connect(server_address)
    buf_len = 10240
    
    # Send data
    data = {}
    tail_ptr = [0]*64
    a = datetime.datetime.now()
    total = 0
    total2 = None
    
    data['cmd'] = 'per_beam_rss4'
    data['args'] = {'tail_ptr':tail_ptr,
                    'rss_mem_addr':0x0093eb00,
                    'storage_size':12,
                    'head_ptr_offset':0x00920000,
    }
        
    message = json.dumps(data).encode('utf-8')
    sock.sendall(message)
        
    # Look for the response
    d = b''
    while True:
         d_tmp = sock.recv(buf_len)
         d += d_tmp
         if not d_tmp or d_tmp[-2:] == '}]':
         # if not d_tmp or d_tmp[-1] == ']':
             break
            
    # print d
    if d:
         response = json.loads(d.decode('utf-8'))
         for r in response:
              total += len(r['rss_data'])
             #print 'Beam index: %2d' % r['beam_index'],  \
                #      '   Last recv. timestamp: %d' % r['timestamp'], \
                #      '   Counter: %d' % r['counter'], \
                #      ' '*(5-len(str(r['counter']))), \
                #      'RSS:', r['rss_data'], \
                #      '\tSNR:', r['snr_data']
              #print r['rss_data']
	      if len(r['rss_data']) > 0: 
              	rssi_wigig = sum(r['rss_data']) / len(r['rss_data'])
	      else:
		rssi_wigig = sum(r['rss_data'])
	      #print rssi_wigig
	      rssi_list.append(rssi_wigig)
              #with open('results/rssi_wigig.txt','a') as file:
              #          file.write(str(rssi_wigig))
              tail_ptr[r['beam_index']] = r['tail_ptr']
                
         if not total2:
              total2 = response[2]['counter']
        
        # print ''
    b = datetime.datetime.now()
    delta = b - a
    #print 'Beacon rate: %.2f/s, %.2f/s' % (total/60.0/delta.total_seconds(), 
     #               (response[2]['counter']-total2)/delta.total_seconds())
    time.sleep(0.5)
        # time.sleep(20)
    
    #print delta

except Exception as e:
    traceback.print_exc()
    print e
    print 'exiting'
finally:
    avg_rssi_wigig = sum(rssi_list) / len(rssi_list)
    print avg_rssi_wigig
    with open('results/rssi_wigig.txt','a') as file:
    	file.write(str(avg_rssi_wigig))
	file.write('\n')
    #print 'connection close'
    sock.close()




